Debian Bug report logs - #716720
freeglut3: possibly wrong use of atexit handler

version graph

Package: freeglut3; Maintainer for freeglut3 is Anton Gladky <gladk@debian.org>; Source for freeglut3 is src:freeglut.

Reported by: "Hans Joachim Desserud" <debian@desserud.org>

Date: Thu, 11 Jul 2013 19:18:01 UTC

Severity: normal

Found in version freeglut/2.8.1-1

Forwarded to https://sourceforge.net/p/freeglut/bugs/201/

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Games Team <pkg-games-devel@lists.alioth.debian.org>:
Bug#716720; Package billard-gl. (Thu, 11 Jul 2013 19:18:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Hans Joachim Desserud" <debian@desserud.org>:
New Bug report received and forwarded. Copy sent to Debian Games Team <pkg-games-devel@lists.alioth.debian.org>. (Thu, 11 Jul 2013 19:18:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Hans Joachim Desserud" <debian@desserud.org>
To: submit@bugs.debian.org
Subject: billard-gl: Crashes when quitting the game
Date: Thu, 11 Jul 2013 21:13:55 +0200
Package: billard-gl
Version: 1.75-13
Severity: important

Dear Maintainer,

Thanks for fixing the crash in configuration->video. :) After checking to
verify it was gone, I noticed the game crash when you quit it. 

Steps to reproduce:
1. Press Esc to bring up the menu
2. Click "Quit"
3. Click "Yes, Quit"

At this point, the following is printed in the terminal:
pure virtual method called
terminate called without an active exception
Aborted


-- System Information:
Debian Release: jessie/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: i386 (i686)

Kernel: Linux 3.9-1-686-pae (SMP w/1 CPU core)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages billard-gl depends on:
ii  billard-gl-data           1.75-13
ii  freeglut3                 2.8.1-1
ii  libc6                     2.17-7
ii  libgcc1                   1:4.8.1-6
ii  libgl1-mesa-glx [libgl1]  9.1.4-1
ii  libglu1-mesa [libglu1]    9.0.0-1
ii  libstdc++6                4.8.1-6

billard-gl recommends no packages.

billard-gl suggests no packages.

-- no debconf information

-- 
mvh / best regards
Hans Joachim
http://desserud.org



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Games Team <pkg-games-devel@lists.alioth.debian.org>:
Bug#716720; Package billard-gl. (Fri, 12 Jul 2013 10:45:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Markus Koschany <apo@gambaru.de>:
Extra info received and forwarded to list. Copy sent to Debian Games Team <pkg-games-devel@lists.alioth.debian.org>. (Fri, 12 Jul 2013 10:45:07 GMT) Full text and rfc822 format available.

Message #10 received at 716720@bugs.debian.org (full text, mbox):

From: Markus Koschany <apo@gambaru.de>
To: 716720@bugs.debian.org, debian@desserud.org
Subject: billard-gl: Crashes when quitting the game
Date: Fri, 12 Jul 2013 12:43:00 +0200
[Message part 1 (text/plain, inline)]
Hi,

i can't reproduce the issue here while running the game on amd64 with
nouveau drivers.

Can you get a backtrace so that it would be possible for us to narrow
the problem down?

https://wiki.debian.org/HowToGetABacktrace

Regards,

Markus

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Games Team <pkg-games-devel@lists.alioth.debian.org>:
Bug#716720; Package billard-gl. (Fri, 12 Jul 2013 15:57:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Hans Joachim Desserud" <debian@desserud.org>:
Extra info received and forwarded to list. Copy sent to Debian Games Team <pkg-games-devel@lists.alioth.debian.org>. (Fri, 12 Jul 2013 15:57:07 GMT) Full text and rfc822 format available.

Message #15 received at 716720@bugs.debian.org (full text, mbox):

From: "Hans Joachim Desserud" <debian@desserud.org>
To: "Markus Koschany " <apo@gambaru.de>, 716720@bugs.debian.org
Subject: Re: billard-gl: Crashes when quitting the game
Date: Fri, 12 Jul 2013 17:20:40 +0200
>i can't reproduce the issue here while running the game on amd64 with
>nouveau drivers.

Hm, I'm also able to reproduce this on Ubuntu Saucy (also an i386 system). It should be
mentioned that both are virtual machines, so I'm not sure which drivers they are using.

>Can you get a backtrace so that it would be possible for us to narrow
>the problem down?
>

Rebuilt the package with debugging symbols, ran it for the first time, picked English
and then quit the game from the in-game menu. (Also happens with other languages
and on subsequent runs though)

(gdb) r
Starting program: /usr/games/billard-gl 
warning: Could not load shared library symbols for linux-gate.so.1.
Do you need "set solib-search-path" or "set sysroot"?
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib/i386-linux-gnu/i686/cmov/libthread_db.so.1".

 BillardGL (C) 2001, 2002 Tobias Nopper, Stefan Disch, Martina Welte

...............................................................................................................................................................................................................................................................................................pure virtual method called
terminate called without an active exception

Program received signal SIGABRT, Aborted.
0xb7fde424 in __kernel_vsyscall ()
(gdb) bt
#0  0xb7fde424 in __kernel_vsyscall ()
#1  0xb7bde83f in __GI_raise (sig=sig@entry=6) at ../nptl/sysdeps/unix/sysv/linux/raise.c:56
#2  0xb7be1cf3 in __GI_abort () at abort.c:90
#3  0xb7e0b3f5 in __gnu_cxx::__verbose_terminate_handler() () from /usr/lib/i386-linux-gnu/libstdc++.so.6
#4  0xb7e09073 in ?? () from /usr/lib/i386-linux-gnu/libstdc++.so.6
#5  0xb7e090af in std::terminate() () from /usr/lib/i386-linux-gnu/libstdc++.so.6
#6  0xb7e09db2 in __cxa_pure_virtual () from /usr/lib/i386-linux-gnu/libstdc++.so.6
#7  0xb68d920a in llvm::BumpPtrAllocator::DeallocateSlabs(llvm::MemSlab*) () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#8  0xb68d9242 in llvm::BumpPtrAllocator::~BumpPtrAllocator() () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#9  0xb5fcc1bf in ?? () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#10 0xb5fcc382 in ?? () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#11 0xb62f338e in llvm::PMDataManager::~PMDataManager() () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#12 0xb62fa6e6 in ?? () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#13 0xb62f147e in llvm::PMTopLevelManager::~PMTopLevelManager() () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#14 0xb62fa7f2 in ?? () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#15 0xb62f1194 in llvm::FunctionPassManager::~FunctionPassManager() () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#16 0xb64511e7 in llvm::JIT::removeModule(llvm::Module*) () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#17 0xb634b1e8 in LLVMRemoveModule () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#18 0xb634b233 in LLVMRemoveModuleProvider () from /usr/lib/i386-linux-gnu/libLLVM-3.2.so.1
#19 0xb7452f9c in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#20 0xb74532d1 in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#21 0xb7471bba in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#22 0xb7472345 in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#23 0xb7383e86 in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#24 0xb74c3626 in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#25 0xb7367c57 in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#26 0xb72d9e88 in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#27 0xb72dae6a in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#28 0xb72b21dc in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#29 0xb735cd59 in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#30 0xb734c898 in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#31 0xb734c97c in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#32 0xb735cf1a in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#33 0xb71b7f81 in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#34 0xb72b6cba in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#35 0xb72cffeb in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#36 0xb7474ab7 in dri_destroy_context () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#37 0xb719403a in ?? () from /usr/lib/i386-linux-gnu/dri/swrast_dri.so
#38 0xb7fa7d86 in ?? () from /usr/lib/i386-linux-gnu/libGL.so.1
#39 0xb7f84530 in ?? () from /usr/lib/i386-linux-gnu/libGL.so.1
#40 0xb7f845ae in ?? () from /usr/lib/i386-linux-gnu/libGL.so.1
#41 0xb7a56933 in XCloseDisplay () from /usr/lib/i386-linux-gnu/libX11.so.6
#42 0xb7ebcb44 in fgDeinitialize () from /usr/lib/i386-linux-gnu/libglut.so.3
#43 0xb7be3421 in __run_exit_handlers (status=status@entry=0, listp=0xb7d5c3e4 <__exit_funcs>, run_list_atexit=run_list_atexit@entry=true) at exit.c:77
#44 0xb7be34ad in __GI_exit (status=0) at exit.c:99
#45 0x0805a827 in Menu::SignalAusfuehrung (this=this@entry=0x8078020 <Menu>, Signal=Signal@entry=850) at Menu.cpp:1972
#46 0x0805b0e2 in Menu::Maustaste (this=0x8078020 <Menu>, Taste=Taste@entry=0, Richtung=Richtung@entry=1, x=x@entry=299, y=y@entry=230) at Menu.cpp:266
#47 0x0804ab13 in Maus (button=0, state=1, x=299, y=230) at Benutzerschnittstelle.cpp:35
#48 0xb7ebf9b0 in glutMainLoopEvent () from /usr/lib/i386-linux-gnu/libglut.so.3
#49 0xb7ebff5c in glutMainLoop () from /usr/lib/i386-linux-gnu/libglut.so.3
#50 0x0804a1f7 in main (argc=1, argv=0xbffff574) at BillardGL.cpp:304

-- 
mvh / best regards
Hans Joachim
http://desserud.org



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Games Team <pkg-games-devel@lists.alioth.debian.org>:
Bug#716720; Package billard-gl. (Fri, 12 Jul 2013 21:51:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Markus Koschany <apo@gambaru.de>:
Extra info received and forwarded to list. Copy sent to Debian Games Team <pkg-games-devel@lists.alioth.debian.org>. (Fri, 12 Jul 2013 21:51:09 GMT) Full text and rfc822 format available.

Message #20 received at 716720@bugs.debian.org (full text, mbox):

From: Markus Koschany <apo@gambaru.de>
To: Hans Joachim Desserud <debian@desserud.org>
Cc: 716720@bugs.debian.org
Subject: Re: billard-gl: Crashes when quitting the game
Date: Fri, 12 Jul 2013 23:46:44 +0200
[Message part 1 (text/plain, inline)]
Thanks for your report and your additional backtrace!

On 12.07.2013 17:20, Hans Joachim Desserud wrote:
> 
>> i can't reproduce the issue here while running the game on amd64 with
>> nouveau drivers.
> 
> Hm, I'm also able to reproduce this on Ubuntu Saucy (also an i386 system). It should be
> mentioned that both are virtual machines, so I'm not sure which drivers they are using.

I have installed this version on the same pc running a parallel
installation of Debian sid (i386) and i still can't reproduce the issue
hence I think we should take a closer look at your virtual machines.


>> Can you get a backtrace so that it would be possible for us to narrow
>> the problem down?
>>
> 
> Rebuilt the package with debugging symbols, ran it for the first time, picked English
> and then quit the game from the in-game menu. (Also happens with other languages
> and on subsequent runs though)

If you can reproduce this crash in the same environment, it is most
likely a valid bug report. However i believe only a minority will ever
be affected by it and severity "normal" might be more appropriate.

What kind of virtualization do you use? Did you install billard-gl in a
clean chroot? Every information about your setup might be useful.

Thanks again for your feedback.

Regards,

Markus

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Games Team <pkg-games-devel@lists.alioth.debian.org>:
Bug#716720; Package billard-gl. (Tue, 16 Jul 2013 20:15:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Hans Joachim Desserud" <debian@desserud.org>:
Extra info received and forwarded to list. Copy sent to Debian Games Team <pkg-games-devel@lists.alioth.debian.org>. (Tue, 16 Jul 2013 20:15:08 GMT) Full text and rfc822 format available.

Message #25 received at 716720@bugs.debian.org (full text, mbox):

From: "Hans Joachim Desserud" <debian@desserud.org>
To: "Markus Koschany " <apo@gambaru.de>
Cc: 716720@bugs.debian.org, control@bugs.debian.org
Subject: Re: billard-gl: Crashes when quitting the game
Date: Tue, 16 Jul 2013 22:12:47 +0200
[Message part 1 (text/plain, inline)]
severity 716720 normal
thanks


Ok, reducing severity since it seems I'm the only one who can trigger this.

>What kind of virtualization do you use? Did you install billard-gl in a
>clean chroot? Every information about your setup might be useful.

The virtual machines are VirtualBox (host: Ubuntu 13.04). Enabling/disabling 
3d hardware acceleration for the vm had no effect. I have also attached the output 
from glxinfo in case that's relevant.

I've done some testing since last time, and I think I've tracked down which change
caused this issue.

I have Ubuntu Saucy (the current development release) where the crash is occuring, 
and Ubuntu 13.04 aka Raring (the latest stable release) where it doesn't crash. Assuming
whatever causing the crash had been introduced since Raring was released, I figured
I'd try to install the newer packages on the old system and see what happened.

First I upgraded billard-gl and -data to 1.17-13, but it closed as expected without any 
error messages. Ok, next stop dependencies.

I pulled in the latest version of the freeglut3 package, and then I got the error messages
and crash when attempting to quit billard-gl. I also verified it went away when I uninstalled
the package and reinstalled the old one.
In other words:
with freeglut3 2.6.0-4ubuntu1 : exits cleanly
with freeglut3 2.8.1-1 : error message and crash

I don't have any older Debian releases to test with right now, otherwise I'd done so,
though since I can reproduce crash in Sid I assume it was also introduced there 
with the new version of the library.

-- 
mvh / best regards
Hans Joachim
http://desserud.org
[glxinfo (application/octet-stream, attachment)]

Severity set to 'normal' from 'important' Request was from "Hans Joachim Desserud" <debian@desserud.org> to control@bugs.debian.org. (Tue, 16 Jul 2013 20:15:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Games Team <pkg-games-devel@lists.alioth.debian.org>:
Bug#716720; Package billard-gl. (Sun, 21 Jul 2013 18:15:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Markus Koschany <apo@gambaru.de>:
Extra info received and forwarded to list. Copy sent to Debian Games Team <pkg-games-devel@lists.alioth.debian.org>. (Sun, 21 Jul 2013 18:15:04 GMT) Full text and rfc822 format available.

Message #32 received at 716720@bugs.debian.org (full text, mbox):

From: Markus Koschany <apo@gambaru.de>
To: Hans Joachim Desserud <debian@desserud.org>
Cc: 716720@bugs.debian.org
Subject: Re: billard-gl: Crashes when quitting the game
Date: Sun, 21 Jul 2013 20:11:22 +0200
[Message part 1 (text/plain, inline)]
reassign 716720 freeglut3
forwarded 716720 https://sourceforge.net/p/freeglut/bugs/201/
thanks


On 16.07.2013 22:12, Hans Joachim Desserud wrote:
[...]

> I've done some testing since last time, and I think I've tracked down which change
> caused this issue.
> 
> I have Ubuntu Saucy (the current development release) where the crash is occuring, 
> and Ubuntu 13.04 aka Raring (the latest stable release) where it doesn't crash. Assuming
> whatever causing the crash had been introduced since Raring was released, I figured
> I'd try to install the newer packages on the old system and see what happened.
> 
> First I upgraded billard-gl and -data to 1.17-13, but it closed as expected without any 
> error messages. Ok, next stop dependencies.
> 
> I pulled in the latest version of the freeglut3 package, and then I got the error messages
> and crash when attempting to quit billard-gl. I also verified it went away when I uninstalled
> the package and reinstalled the old one.
> In other words:
> with freeglut3 2.6.0-4ubuntu1 : exits cleanly
> with freeglut3 2.8.1-1 : error message and crash
> 
> I don't have any older Debian releases to test with right now, otherwise I'd done so,
> though since I can reproduce crash in Sid I assume it was also introduced there 
> with the new version of the library.

I think this is most likely a bug and a regression in freeglut3, version
2.8.1. I have forwarded this bug report to freeglut's upstream bug
tracker at sourceforge.net.

https://sourceforge.net/p/freeglut/bugs/201/

I think the way how billard-gl calls "exit" is correct and there is not
much what we can do here to improve the situation.

Regards,

Markus


[signature.asc (application/pgp-signature, attachment)]

Bug reassigned from package 'billard-gl' to 'freeglut3'. Request was from Markus Koschany <apo@gambaru.de> to control@bugs.debian.org. (Sun, 21 Jul 2013 18:15:07 GMT) Full text and rfc822 format available.

No longer marked as found in versions billard-gl/1.75-13. Request was from Markus Koschany <apo@gambaru.de> to control@bugs.debian.org. (Sun, 21 Jul 2013 18:15:08 GMT) Full text and rfc822 format available.

Set Bug forwarded-to-address to 'https://sourceforge.net/p/freeglut/bugs/201/'. Request was from Markus Koschany <apo@gambaru.de> to control@bugs.debian.org. (Sun, 21 Jul 2013 18:15:09 GMT) Full text and rfc822 format available.

Changed Bug title to 'freeglut3: possibly wrong use of atexit handler' from 'billard-gl: Crashes when quitting the game' Request was from Markus Koschany <apo@gambaru.de> to control@bugs.debian.org. (Sun, 21 Jul 2013 18:24:05 GMT) Full text and rfc822 format available.

Marked as found in versions freeglut/2.8.1-1. Request was from Markus Koschany <apo@gambaru.de> to control@bugs.debian.org. (Sun, 21 Jul 2013 18:33:07 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 06:58:58 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.